/**
 * This file was auto-generated by swagger-to-ts.
 * Do not make direct changes to the file.
 */

export interface definitions {
  wishlist_Post: {
    /**
     * The customer id.
     */
    customer_id: number
    /**
     * Whether the wishlist is available to the public.
     */
    is_public?: boolean
    /**
     * The title of the wishlist.
     */
    name?: string
    /**
     * Array of Wishlist items.
     */
    items?: {
      /**
       * The ID of the product.
       */
      product_id?: number
      /**
       * The variant ID of the product.
       */
      variant_id?: number
    }[]
  }
  wishlist_Put: {
    /**
     * The customer id.
     */
    customer_id: number
    /**
     * Whether the wishlist is available to the public.
     */
    is_public?: boolean
    /**
     * The title of the wishlist.
     */
    name?: string
    /**
     * Array of Wishlist items.
     */
    items?: {
      /**
       * The ID of the item
       */
      id?: number
      /**
       * The ID of the product.
       */
      product_id?: number
      /**
       * The variant ID of the item.
       */
      variant_id?: number
    }[]
  }
  wishlist_Full: {
    /**
     * Wishlist ID, provided after creating a wishlist with a POST.
     */
    id?: number
    /**
     * The ID the customer to which the wishlist belongs.
     */
    customer_id?: number
    /**
     * The Wishlist's name.
     */
    name?: string
    /**
     * Whether the Wishlist is available to the public.
     */
    is_public?: boolean
    /**
     * The token of the Wishlist. This is created internally within BigCommerce. The Wishlist ID is to be used for external apps. Read-Only
     */
    token?: string
    /**
     * Array of Wishlist items
     */
    items?: definitions['wishlistItem_Full'][]
  }
  wishlistItem_Full: {
    /**
     * The ID of the item
     */
    id?: number
    /**
     * The ID of the product.
     */
    product_id?: number
    /**
     * The variant ID of the item.
     */
    variant_id?: number
  }
  wishlistItem_Post: {
    /**
     * The ID of the product.
     */
    product_id?: number
    /**
     * The variant ID of the product.
     */
    variant_id?: number
  }
  /**
   * Data about the response, including pagination and collection totals.
   */
  pagination: {
    /**
     * Total number of items in the result set.
     */
    total?: number
    /**
     * Total number of items in the collection response.
     */
    count?: number
    /**
     * The amount of items returned in the collection per page, controlled by the limit parameter.
     */
    per_page?: number
    /**
     * The page you are currently on within the collection.
     */
    current_page?: number
    /**
     * The total number of pages in the collection.
     */
    total_pages?: number
  }
  error: { status?: number; title?: string; type?: string }
  metaCollection: { pagination?: definitions['pagination'] }
}
